//     Example code.
//
//                             Fernando Anton - Mitra / Spanish Lords
//                                                  fernando@ergos.es
#include <stdio.h>
#include <conio.h>
#include <process.h>
#include "slint.hpp"
#include "slkeys.hpp"

void Error(long What);
void PutColor(int Col,int R,int G,int B);
void WaitForRetrace();

void main()
{
  printf("Installing keyboard dual handler... ");
  if (!InstallKeyboard()) Error(1);
  printf("done.\n\n");
  printf("Press ESC to exit.\n");
  printf("Press LeftAlt+Intro to splash.\n");

  while (!Teclas[kbEsc])
  {
    WaitForRetrace();
    if (Teclas[kbLAlt]&&Teclas[kbIntro])
       PutColor(0,63,63,63);
    else
       PutColor(0,0,0,0);
  }

  printf("\nDeinstalling keyboard dual handler... ");
  if (!UnInstallKeyboard()) Error(2);
  printf("done.\n");
}

void PutColor(int Col,int R,int G,int B)
{
   outp(0x3C8,Col);
   outp(0x3C9,R);
   outp(0x3C9,G);
   outp(0x3C9,B);
}

void WaitForRetrace()
{
   while ((inp(0x3DA) & 8) == 0);
}

void Error(long What)
{
   printf("\nFatal error:\n   ");
   switch(What)
   {
     case 1 :
        printf("Keyboard handler couldn't be installed\n");
        break;
     case 2 :
        printf("Keyboard handler couldn't be deinstalled\n");
        break;
   }
   exit(What);
}
